{-# LANGUAGE RankNTypes,
             ExistentialQuantification,
             ImpredicativeTypes,
             TypeOperators
 #-}

module AOP.Internal.AOTType where

import AOP.Internal.Aspect
import AOP.Internal.Pointcut
import Control.Monad.Zipper
import Control.Monad.Identity

-- | This module defines the AOT type. It is a separate module to avoid circular dependencies between modules.

newtype AOT m a = AOT { run :: AspectEnv (AOT m) -> m (a, AspectEnv (AOT m)) }

data EPC m = forall a b. EPC (PC m a b)

newtype AOT_s m a = AOT_s { run_s :: AspectEnv (AOT_s m) -> EPC (AOT_s m) -> 
                                     m (a, (AspectEnv (AOT_s m), EPC (AOT_s m)))}

data SP m = forall a1 b1. SP (PC m a1 b1) (AspectEnv m)

newtype AOT_sp m a = AOT_sp { run_sp :: AspectEnv (AOT_sp m) -> SP (AOT_sp m) ->
                                        m (a, (AspectEnv (AOT_sp m), SP (AOT_sp m)))}

type AOTZ = (IdentityT :> AOT_zipper)

newtype AOT_zipper m a = AOT_zipper { run_zipper :: AspectEnv (AOTZ m) -> m (a, AspectEnv (AOTZ m)) }


