{-# LANGUAGE ScopedTypeVariables
  #-}

import AOP.Default
import AOP.JPStackT
import AOP.Internal.TestHelper
import AOP.Test.CriticalComputation

main :: IO Counts
main = runCflowTests

-- Test Suite
runCflowTests =
         let tests = TestList [test_client1]
         in runTestTT tests

-------------------------------------------------------------------------------- 
{- This example tests that (aspect (pcCall stdComputation) adv) does not
   interfere with evaluation of criticalComputation, because the internal join points
   are protected. So the expected result is equal to that of just calling criticalComputation.
   criticalComputation and runSafe are imported from CriticalComputation.hs
-}

runProg c = runIdentity (runSafe c)

adv proceed n = return 0

client1 n = runProg (program1 n)
program1 n = do              
              deploy (aspect (pcCall stdComputation) adv)
              deploy jpStackAspect
              criticalComputation # n
--Tests
prop_client1 (n::Integer) = client1 n == runProg (criticalComputation # n)
test_client1 = TestLabel "Client 1" (testProperty prop_client1)

runProg2 c = runIdentity (runJPStackT (runAOT_s (EPC pcFalse) c) [])

-- this is rejected because runProg2 expects something of 
-- type :: AOT_s (JpStackT Identity) a
--client2 n = runProg2 (program1 n) 